Loading...
Searching...
No Matches
pcl::UnaryClassifier< PointT > Class Template Reference

`#include <pcl/segmentation/unary_classifier.h>`

## Public Member Functions

| UnaryClassifier ()
| Constructor that sets default values for member variables.
| ~UnaryClassifier ()
| This destructor destroys the cloud...
void | setInputCloud (typename pcl::PointCloud< PointT >::Ptr input_cloud)
| This method sets the input cloud.
void | train (pcl::PointCloud< pcl::FPFHSignature33 >::Ptr &output)
void | trainWithLabel (std::vector< pcl::PointCloud< pcl::FPFHSignature33 >, Eigen::aligned_allocator< pcl::PointCloud< pcl::FPFHSignature33 > > > &output)
void | segment (pcl::PointCloud< pcl::PointXYZRGBL >::Ptr &out)
void | queryFeatureDistances (std::vector< pcl::PointCloud< pcl::FPFHSignature33 >::Ptr > &trained_features, pcl::PointCloud< pcl::FPFHSignature33 >::Ptr query_features, pcl::Indices &indi, std::vector< float > &dist)
void | assignLabels (pcl::Indices &indi, std::vector< float > &dist, int n_feature_means, float feature_threshold, pcl::PointCloud< pcl::PointXYZRGBL >::Ptr out)
void | setClusterSize (unsigned int k)
void | setNormalRadiusSearch (float param)
void | setFPFHRadiusSearch (float param)
void | setLabelField (bool l)
void | setTrainedFeatures (std::vector< pcl::PointCloud< pcl::FPFHSignature33 >::Ptr > &features)
void | setFeatureThreshold (float threshold)

## Protected Member Functions

void | convertCloud (typename pcl::PointCloud< PointT >::Ptr in, pcl::PointCloud< pcl::PointXYZ >::Ptr out)
void | convertCloud (typename pcl::PointCloud< PointT >::Ptr in, pcl::PointCloud< pcl::PointXYZRGBL >::Ptr out)
void | findClusters (typename pcl::PointCloud< PointT >::Ptr in, std::vector< int > &cluster_numbers)
void | getCloudWithLabel (typename pcl::PointCloud< PointT >::Ptr in, pcl::PointCloud< pcl::PointXYZ >::Ptr out, int label_num)
void | computeFPFH (pcl::PointCloud< pcl::PointXYZ >::Ptr in, pcl::PointCloud< pcl::FPFHSignature33 >::Ptr out, float normal_radius_search, float fpfh_radius_search)
void | kmeansClustering (pcl::PointCloud< pcl::FPFHSignature33 >::Ptr in, pcl::PointCloud< pcl::FPFHSignature33 >::Ptr out, int k)

## Protected Attributes

pcl::PointCloud< PointT >::Ptr | input_cloud_ {new pcl::PointCloud<PointT>}
| Contains the input cloud.
bool | label_field_ {false}
unsigned int | cluster_size_ {0}
float | normal_radius_search_ {0.01f}
float | fpfh_radius_search_ {0.05f}
float | feature_threshold_ {5.0}
std::vector< pcl::PointCloud< pcl::FPFHSignature33 >::Ptr > | trained_features_ {}

## Detailed Description

template<typename PointT>
class pcl::UnaryClassifier< PointT >

Definition at line 57 of file unary_classifier.h.

## Constructor & Destructor Documentation

## UnaryClassifier()

template<typename PointT >

pcl::UnaryClassifier< PointT >::UnaryClassifier | ( |  | ) |

default

Constructor that sets default values for member variables.

## ~UnaryClassifier()

template<typename PointT >

pcl::UnaryClassifier< PointT >::~UnaryClassifier | ( |  | ) |

default

This destructor destroys the cloud...

## Member Function Documentation

## assignLabels()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::assignLabels | ( | pcl::Indices & | indi,
|  | std::vector< float > & | dist,
|  | int | n_feature_means,
|  | float | feature_threshold,
|  | pcl::PointCloud< pcl::PointXYZRGBL >::Ptr | out
| ) |  |

Definition at line 320 of file unary_classifier.hpp.

References pcl::PointCloud< PointT >::size().

## computeFPFH()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::computeFPFH | ( | pcl::PointCloud< pcl::PointXYZ >::Ptr | in,
|  | pcl::PointCloud< pcl::FPFHSignature33 >::Ptr | out,
|  | float | normal_radius_search,
|  | float | fpfh_radius_search
| ) |  |

protected

Definition at line 195 of file unary_classifier.hpp.

References pcl::Feature< PointInT, PointOutT >::compute(), pcl::PCLBase< PointT >::setInputCloud(), pcl::NormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::setInputNormals(), pcl::Feature< PointInT, PointOutT >::setRadiusSearch(), and pcl::Feature< PointInT, PointOutT >::setSearchMethod().

## convertCloud() [1/2]

template<typename PointT >

void pcl::UnaryClassifier< PointT >::convertCloud | ( | typename pcl::PointCloud< PointT >::Ptr | in,
|  | pcl::PointCloud< pcl::PointXYZ >::Ptr | out
| ) |  |

protected

Definition at line 79 of file unary_classifier.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

## convertCloud() [2/2]

template<typename PointT >

void pcl::UnaryClassifier< PointT >::convertCloud | ( | typename pcl::PointCloud< PointT >::Ptr | in,
|  | pcl::PointCloud< pcl::PointXYZRGBL >::Ptr | out
| ) |  |

protected

Definition at line 100 of file unary_classifier.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::_PointXYZRGBL::label, pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

## findClusters()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::findClusters | ( | typename pcl::PointCloud< PointT >::Ptr | in,
|  | std::vector< int > & | cluster_numbers
| ) |  |

protected

Definition at line 127 of file unary_classifier.hpp.

## getCloudWithLabel()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::getCloudWithLabel | ( | typename pcl::PointCloud< PointT >::Ptr | in,
|  | pcl::PointCloud< pcl::PointXYZ >::Ptr | out,
|  | int | label_num
| ) |  |

protected

Definition at line 160 of file unary_classifier.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::push_back(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

## kmeansClustering()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::kmeansClustering | ( | pcl::PointCloud< pcl::FPFHSignature33 >::Ptr | in,
|  | pcl::PointCloud< pcl::FPFHSignature33 >::Ptr | out,
|  | int | k
| ) |  |

protected

Definition at line 224 of file unary_classifier.hpp.

References pcl::Kmeans::addDataPoint(), pcl::Kmeans::get_centroids(), pcl::PointCloud< PointT >::height, pcl::FPFHSignature33::histogram, pcl::PointCloud< PointT >::is_dense, pcl::Kmeans::kMeans(), pcl::PointCloud< PointT >::points, pcl::Kmeans::setClusterSize(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

## queryFeatureDistances()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::queryFeatureDistances | ( | std::vector< pcl::PointCloud< pcl::FPFHSignature33 >::Ptr > & | trained_features,
|  | pcl::PointCloud< pcl::FPFHSignature33 >::Ptr | query_features,
|  | pcl::Indices & | indi,
|  | std::vector< float > & | dist
| ) |  |

Definition at line 263 of file unary_classifier.hpp.

References pcl::PointCloud< PointT >::size().

## segment()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::segment | ( | pcl::PointCloud< pcl::PointXYZRGBL >::Ptr & | out | ) |

Definition at line 395 of file unary_classifier.hpp.

## setClusterSize()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::setClusterSize | ( | unsigned int | k | ) |

inline

Definition at line 98 of file unary_classifier.h.

## setFeatureThreshold()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::setFeatureThreshold | ( | float | threshold | ) |

inline

Definition at line 113 of file unary_classifier.h.

## setFPFHRadiusSearch()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::setFPFHRadiusSearch | ( | float | param | ) |

inline

Definition at line 104 of file unary_classifier.h.

## setInputCloud()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::setInputCloud | ( | typename pcl::PointCloud< PointT >::Ptr | input_cloud | ) |

This method sets the input cloud.

Parameters

  [in] | input_cloud | input point cloud

Definition at line 63 of file unary_classifier.hpp.

## setLabelField()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::setLabelField | ( | bool | l | ) |

inline

Definition at line 107 of file unary_classifier.h.

## setNormalRadiusSearch()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::setNormalRadiusSearch | ( | float | param | ) |

inline

Definition at line 101 of file unary_classifier.h.

## setTrainedFeatures()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::setTrainedFeatures | ( | std::vector< pcl::PointCloud< pcl::FPFHSignature33 >::Ptr > & | features | ) |

inline

Definition at line 110 of file unary_classifier.h.

## train()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::train | ( | pcl::PointCloud< pcl::FPFHSignature33 >::Ptr & | output | ) |

Definition at line 346 of file unary_classifier.hpp.

## trainWithLabel()

template<typename PointT >

void pcl::UnaryClassifier< PointT >::trainWithLabel | ( | std::vector< pcl::PointCloud< pcl::FPFHSignature33 >, Eigen::aligned_allocator< pcl::PointCloud< pcl::FPFHSignature33 > > > & | output | ) |

Definition at line 364 of file unary_classifier.hpp.

## Member Data Documentation

## cluster_size_

template<typename PointT >

unsigned int pcl::UnaryClassifier< PointT >::cluster_size_ {0}

protected

Definition at line 152 of file unary_classifier.h.

## feature_threshold_

template<typename PointT >

float pcl::UnaryClassifier< PointT >::feature_threshold_ {5.0}

protected

Definition at line 156 of file unary_classifier.h.

## fpfh_radius_search_

template<typename PointT >

float pcl::UnaryClassifier< PointT >::fpfh_radius_search_ {0.05f}

protected

Definition at line 155 of file unary_classifier.h.

## input_cloud_

template<typename PointT >

pcl::PointCloud<PointT>::Ptr pcl::UnaryClassifier< PointT >::input_cloud_ {new pcl::PointCloud<PointT>}

protected

Contains the input cloud.

Definition at line 148 of file unary_classifier.h.

## label_field_

template<typename PointT >

bool pcl::UnaryClassifier< PointT >::label_field_ {false}

protected

Definition at line 150 of file unary_classifier.h.

## normal_radius_search_

template<typename PointT >

float pcl::UnaryClassifier< PointT >::normal_radius_search_ {0.01f}

protected

Definition at line 154 of file unary_classifier.h.

## trained_features_

template<typename PointT >

std::vector<pcl::PointCloud<pcl::FPFHSignature33>::Ptr> pcl::UnaryClassifier< PointT >::trained_features_ {}

protected

Definition at line 159 of file unary_classifier.h.

The documentation for this class was generated from the following files:

- pcl/segmentation/unary_classifier.h
- pcl/segmentation/impl/unary_classifier.hpp